/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */ 
/**
 * <copyright>
 * </copyright>
 *
 * $Id: InboundEventTypeImpl.java,v 1.1 2006/06/27 15:10:40 crmiles Exp $
 */
package com.ibm.wbimonitor.xml.model.mm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.wbimonitor.xml.model.mm.EventDeliveryOptionMultipleMatchesType;
import com.ibm.wbimonitor.xml.model.mm.EventDeliveryOptionNoMatchesType;
import com.ibm.wbimonitor.xml.model.mm.EventDeliveryOptionOneMatchType;
import com.ibm.wbimonitor.xml.model.mm.EventPartType;
import com.ibm.wbimonitor.xml.model.mm.ExpressionSpecificationType;
import com.ibm.wbimonitor.xml.model.mm.InboundEventType;
import com.ibm.wbimonitor.xml.model.mm.MmPackage;
import com.ibm.wbimonitor.xml.model.mm.util.EventTypeResolver;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Inbound Event Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getEventPart <em>Event Part</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getCorrelationPredicate <em>Correlation Predicate</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getFilter <em>Filter</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getEventSequenceIDPath <em>Event Sequence ID Path</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getExtensionName <em>Extension Name</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getMultipleCorrelationMatches <em>Multiple Correlation Matches</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getNoCorrelationMatches <em>No Correlation Matches</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getOneCorrelationMatch <em>One Correlation Match</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#getRootElement <em>Root Element</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.InboundEventTypeImpl#isTerminateContext <em>Terminate Context</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InboundEventTypeImpl extends NamedElementTypeImpl implements InboundEventType {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2007.";  //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getEventPart() <em>Event Part</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventPart()
	 * @generated
	 * @ordered
	 */
	protected EList eventPart = null;

	/**
	 * The cached value of the '{@link #getCorrelationPredicate() <em>Correlation Predicate</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCorrelationPredicate()
	 * @generated
	 * @ordered
	 */
	protected ExpressionSpecificationType correlationPredicate = null;

	/**
	 * The cached value of the '{@link #getFilter() <em>Filter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFilter()
	 * @generated
	 * @ordered
	 */
	protected ExpressionSpecificationType filter = null;

	/**
	 * The default value of the '{@link #getEventSequenceIDPath() <em>Event Sequence ID Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventSequenceIDPath()
	 * @generated
	 * @ordered
	 */
	protected static final String EVENT_SEQUENCE_ID_PATH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getEventSequenceIDPath() <em>Event Sequence ID Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventSequenceIDPath()
	 * @generated
	 * @ordered
	 */
	protected String eventSequenceIDPath = EVENT_SEQUENCE_ID_PATH_EDEFAULT;

	/**
	 * The default value of the '{@link #getExtensionName() <em>Extension Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensionName()
	 * @generated
	 * @ordered
	 */
	protected static final String EXTENSION_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getExtensionName() <em>Extension Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensionName()
	 * @generated
	 * @ordered
	 */
	protected String extensionName = EXTENSION_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getMultipleCorrelationMatches() <em>Multiple Correlation Matches</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMultipleCorrelationMatches()
	 * @generated
	 * @ordered
	 */
	protected static final EventDeliveryOptionMultipleMatchesType MULTIPLE_CORRELATION_MATCHES_EDEFAULT = EventDeliveryOptionMultipleMatchesType.IGNORE_LITERAL;

	/**
	 * The cached value of the '{@link #getMultipleCorrelationMatches() <em>Multiple Correlation Matches</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMultipleCorrelationMatches()
	 * @generated
	 * @ordered
	 */
	protected EventDeliveryOptionMultipleMatchesType multipleCorrelationMatches = MULTIPLE_CORRELATION_MATCHES_EDEFAULT;

	/**
	 * This is true if the Multiple Correlation Matches attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean multipleCorrelationMatchesESet = false;

	/**
	 * The default value of the '{@link #getNoCorrelationMatches() <em>No Correlation Matches</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNoCorrelationMatches()
	 * @generated
	 * @ordered
	 */
	protected static final EventDeliveryOptionNoMatchesType NO_CORRELATION_MATCHES_EDEFAULT = EventDeliveryOptionNoMatchesType.IGNORE_LITERAL;

	/**
	 * The cached value of the '{@link #getNoCorrelationMatches() <em>No Correlation Matches</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNoCorrelationMatches()
	 * @generated
	 * @ordered
	 */
	protected EventDeliveryOptionNoMatchesType noCorrelationMatches = NO_CORRELATION_MATCHES_EDEFAULT;

	/**
	 * This is true if the No Correlation Matches attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean noCorrelationMatchesESet = false;

	/**
	 * The default value of the '{@link #getOneCorrelationMatch() <em>One Correlation Match</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOneCorrelationMatch()
	 * @generated
	 * @ordered
	 */
	protected static final EventDeliveryOptionOneMatchType ONE_CORRELATION_MATCH_EDEFAULT = EventDeliveryOptionOneMatchType.IGNORE_LITERAL;

	/**
	 * The cached value of the '{@link #getOneCorrelationMatch() <em>One Correlation Match</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOneCorrelationMatch()
	 * @generated
	 * @ordered
	 */
	protected EventDeliveryOptionOneMatchType oneCorrelationMatch = ONE_CORRELATION_MATCH_EDEFAULT;

	/**
	 * This is true if the One Correlation Match attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean oneCorrelationMatchESet = false;

	/**
	 * The default value of the '{@link #getRootElement() <em>Root Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRootElement()
	 * @generated
	 * @ordered
	 */
	protected static final Object ROOT_ELEMENT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getRootElement() <em>Root Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRootElement()
	 * @generated
	 * @ordered
	 */
	protected Object rootElement = ROOT_ELEMENT_EDEFAULT;

	/**
	 * The default value of the '{@link #isTerminateContext() <em>Terminate Context</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isTerminateContext()
	 * @generated
	 * @ordered
	 */
	protected static final boolean TERMINATE_CONTEXT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isTerminateContext() <em>Terminate Context</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isTerminateContext()
	 * @generated
	 * @ordered
	 */
	protected boolean terminateContext = TERMINATE_CONTEXT_EDEFAULT;

	/**
	 * This is true if the Terminate Context attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean terminateContextESet = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InboundEventTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MmPackage.Literals.INBOUND_EVENT_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getEventPart() {
		if (eventPart == null) {
			eventPart = new EObjectContainmentEList(EventPartType.class, this, MmPackage.INBOUND_EVENT_TYPE__EVENT_PART);
		}
		return eventPart;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpressionSpecificationType getCorrelationPredicate() {
		return correlationPredicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCorrelationPredicate(ExpressionSpecificationType newCorrelationPredicate, NotificationChain msgs) {
		ExpressionSpecificationType oldCorrelationPredicate = correlationPredicate;
		correlationPredicate = newCorrelationPredicate;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE, oldCorrelationPredicate, newCorrelationPredicate);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCorrelationPredicate(ExpressionSpecificationType newCorrelationPredicate) {
		if (newCorrelationPredicate != correlationPredicate) {
			NotificationChain msgs = null;
			if (correlationPredicate != null)
				msgs = ((InternalEObject)correlationPredicate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE, null, msgs);
			if (newCorrelationPredicate != null)
				msgs = ((InternalEObject)newCorrelationPredicate).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE, null, msgs);
			msgs = basicSetCorrelationPredicate(newCorrelationPredicate, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE, newCorrelationPredicate, newCorrelationPredicate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpressionSpecificationType getFilter() {
		return filter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFilter(ExpressionSpecificationType newFilter, NotificationChain msgs) {
		ExpressionSpecificationType oldFilter = filter;
		filter = newFilter;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__FILTER, oldFilter, newFilter);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFilter(ExpressionSpecificationType newFilter) {
		if (newFilter != filter) {
			NotificationChain msgs = null;
			if (filter != null)
				msgs = ((InternalEObject)filter).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.INBOUND_EVENT_TYPE__FILTER, null, msgs);
			if (newFilter != null)
				msgs = ((InternalEObject)newFilter).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.INBOUND_EVENT_TYPE__FILTER, null, msgs);
			msgs = basicSetFilter(newFilter, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__FILTER, newFilter, newFilter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getEventSequenceIDPath() {
		return eventSequenceIDPath;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventSequenceIDPath(String newEventSequenceIDPath) {
		String oldEventSequenceIDPath = eventSequenceIDPath;
		eventSequenceIDPath = newEventSequenceIDPath;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__EVENT_SEQUENCE_ID_PATH, oldEventSequenceIDPath, eventSequenceIDPath));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getExtensionName() {
		return extensionName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExtensionName(String newExtensionName) {
		String oldExtensionName = extensionName;
		extensionName = newExtensionName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__EXTENSION_NAME, oldExtensionName, extensionName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventDeliveryOptionMultipleMatchesType getMultipleCorrelationMatches() {
		return multipleCorrelationMatches;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMultipleCorrelationMatches(EventDeliveryOptionMultipleMatchesType newMultipleCorrelationMatches) {
		EventDeliveryOptionMultipleMatchesType oldMultipleCorrelationMatches = multipleCorrelationMatches;
		multipleCorrelationMatches = newMultipleCorrelationMatches == null ? MULTIPLE_CORRELATION_MATCHES_EDEFAULT : newMultipleCorrelationMatches;
		boolean oldMultipleCorrelationMatchesESet = multipleCorrelationMatchesESet;
		multipleCorrelationMatchesESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__MULTIPLE_CORRELATION_MATCHES, oldMultipleCorrelationMatches, multipleCorrelationMatches, !oldMultipleCorrelationMatchesESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetMultipleCorrelationMatches() {
		EventDeliveryOptionMultipleMatchesType oldMultipleCorrelationMatches = multipleCorrelationMatches;
		boolean oldMultipleCorrelationMatchesESet = multipleCorrelationMatchesESet;
		multipleCorrelationMatches = MULTIPLE_CORRELATION_MATCHES_EDEFAULT;
		multipleCorrelationMatchesESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.INBOUND_EVENT_TYPE__MULTIPLE_CORRELATION_MATCHES, oldMultipleCorrelationMatches, MULTIPLE_CORRELATION_MATCHES_EDEFAULT, oldMultipleCorrelationMatchesESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetMultipleCorrelationMatches() {
		return multipleCorrelationMatchesESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventDeliveryOptionNoMatchesType getNoCorrelationMatches() {
		return noCorrelationMatches;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNoCorrelationMatches(EventDeliveryOptionNoMatchesType newNoCorrelationMatches) {
		EventDeliveryOptionNoMatchesType oldNoCorrelationMatches = noCorrelationMatches;
		noCorrelationMatches = newNoCorrelationMatches == null ? NO_CORRELATION_MATCHES_EDEFAULT : newNoCorrelationMatches;
		boolean oldNoCorrelationMatchesESet = noCorrelationMatchesESet;
		noCorrelationMatchesESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__NO_CORRELATION_MATCHES, oldNoCorrelationMatches, noCorrelationMatches, !oldNoCorrelationMatchesESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetNoCorrelationMatches() {
		EventDeliveryOptionNoMatchesType oldNoCorrelationMatches = noCorrelationMatches;
		boolean oldNoCorrelationMatchesESet = noCorrelationMatchesESet;
		noCorrelationMatches = NO_CORRELATION_MATCHES_EDEFAULT;
		noCorrelationMatchesESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.INBOUND_EVENT_TYPE__NO_CORRELATION_MATCHES, oldNoCorrelationMatches, NO_CORRELATION_MATCHES_EDEFAULT, oldNoCorrelationMatchesESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetNoCorrelationMatches() {
		return noCorrelationMatchesESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventDeliveryOptionOneMatchType getOneCorrelationMatch() {
		return oneCorrelationMatch;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOneCorrelationMatch(EventDeliveryOptionOneMatchType newOneCorrelationMatch) {
		EventDeliveryOptionOneMatchType oldOneCorrelationMatch = oneCorrelationMatch;
		oneCorrelationMatch = newOneCorrelationMatch == null ? ONE_CORRELATION_MATCH_EDEFAULT : newOneCorrelationMatch;
		boolean oldOneCorrelationMatchESet = oneCorrelationMatchESet;
		oneCorrelationMatchESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__ONE_CORRELATION_MATCH, oldOneCorrelationMatch, oneCorrelationMatch, !oldOneCorrelationMatchESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetOneCorrelationMatch() {
		EventDeliveryOptionOneMatchType oldOneCorrelationMatch = oneCorrelationMatch;
		boolean oldOneCorrelationMatchESet = oneCorrelationMatchESet;
		oneCorrelationMatch = ONE_CORRELATION_MATCH_EDEFAULT;
		oneCorrelationMatchESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.INBOUND_EVENT_TYPE__ONE_CORRELATION_MATCH, oldOneCorrelationMatch, ONE_CORRELATION_MATCH_EDEFAULT, oldOneCorrelationMatchESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetOneCorrelationMatch() {
		return oneCorrelationMatchESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getRootElement() {
		return rootElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRootElement(Object newRootElement) {
		Object oldRootElement = rootElement;
		rootElement = newRootElement;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__ROOT_ELEMENT, oldRootElement, rootElement));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isTerminateContext() {
		return terminateContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTerminateContext(boolean newTerminateContext) {
		boolean oldTerminateContext = terminateContext;
		terminateContext = newTerminateContext;
		boolean oldTerminateContextESet = terminateContextESet;
		terminateContextESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.INBOUND_EVENT_TYPE__TERMINATE_CONTEXT, oldTerminateContext, terminateContext, !oldTerminateContextESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetTerminateContext() {
		boolean oldTerminateContext = terminateContext;
		boolean oldTerminateContextESet = terminateContextESet;
		terminateContext = TERMINATE_CONTEXT_EDEFAULT;
		terminateContextESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.INBOUND_EVENT_TYPE__TERMINATE_CONTEXT, oldTerminateContext, TERMINATE_CONTEXT_EDEFAULT, oldTerminateContextESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetTerminateContext() {
		return terminateContextESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_PART:
				return ((InternalEList)getEventPart()).basicRemove(otherEnd, msgs);
			case MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE:
				return basicSetCorrelationPredicate(null, msgs);
			case MmPackage.INBOUND_EVENT_TYPE__FILTER:
				return basicSetFilter(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_PART:
				return getEventPart();
			case MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE:
				return getCorrelationPredicate();
			case MmPackage.INBOUND_EVENT_TYPE__FILTER:
				return getFilter();
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_SEQUENCE_ID_PATH:
				return getEventSequenceIDPath();
			case MmPackage.INBOUND_EVENT_TYPE__EXTENSION_NAME:
				return getExtensionName();
			case MmPackage.INBOUND_EVENT_TYPE__MULTIPLE_CORRELATION_MATCHES:
				return getMultipleCorrelationMatches();
			case MmPackage.INBOUND_EVENT_TYPE__NO_CORRELATION_MATCHES:
				return getNoCorrelationMatches();
			case MmPackage.INBOUND_EVENT_TYPE__ONE_CORRELATION_MATCH:
				return getOneCorrelationMatch();
			case MmPackage.INBOUND_EVENT_TYPE__ROOT_ELEMENT:
				return getRootElement();
			case MmPackage.INBOUND_EVENT_TYPE__TERMINATE_CONTEXT:
				return isTerminateContext() ? Boolean.TRUE : Boolean.FALSE;
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_PART:
				getEventPart().clear();
				getEventPart().addAll((Collection)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE:
				setCorrelationPredicate((ExpressionSpecificationType)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__FILTER:
				setFilter((ExpressionSpecificationType)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_SEQUENCE_ID_PATH:
				setEventSequenceIDPath((String)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__EXTENSION_NAME:
				setExtensionName((String)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__MULTIPLE_CORRELATION_MATCHES:
				setMultipleCorrelationMatches((EventDeliveryOptionMultipleMatchesType)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__NO_CORRELATION_MATCHES:
				setNoCorrelationMatches((EventDeliveryOptionNoMatchesType)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__ONE_CORRELATION_MATCH:
				setOneCorrelationMatch((EventDeliveryOptionOneMatchType)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__ROOT_ELEMENT:
				setRootElement((Object)newValue);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__TERMINATE_CONTEXT:
				setTerminateContext(((Boolean)newValue).booleanValue());
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_PART:
				getEventPart().clear();
				return;
			case MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE:
				setCorrelationPredicate((ExpressionSpecificationType)null);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__FILTER:
				setFilter((ExpressionSpecificationType)null);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_SEQUENCE_ID_PATH:
				setEventSequenceIDPath(EVENT_SEQUENCE_ID_PATH_EDEFAULT);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__EXTENSION_NAME:
				setExtensionName(EXTENSION_NAME_EDEFAULT);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__MULTIPLE_CORRELATION_MATCHES:
				unsetMultipleCorrelationMatches();
				return;
			case MmPackage.INBOUND_EVENT_TYPE__NO_CORRELATION_MATCHES:
				unsetNoCorrelationMatches();
				return;
			case MmPackage.INBOUND_EVENT_TYPE__ONE_CORRELATION_MATCH:
				unsetOneCorrelationMatch();
				return;
			case MmPackage.INBOUND_EVENT_TYPE__ROOT_ELEMENT:
				setRootElement(ROOT_ELEMENT_EDEFAULT);
				return;
			case MmPackage.INBOUND_EVENT_TYPE__TERMINATE_CONTEXT:
				unsetTerminateContext();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_PART:
				return eventPart != null && !eventPart.isEmpty();
			case MmPackage.INBOUND_EVENT_TYPE__CORRELATION_PREDICATE:
				return correlationPredicate != null;
			case MmPackage.INBOUND_EVENT_TYPE__FILTER:
				return filter != null;
			case MmPackage.INBOUND_EVENT_TYPE__EVENT_SEQUENCE_ID_PATH:
				return EVENT_SEQUENCE_ID_PATH_EDEFAULT == null ? eventSequenceIDPath != null : !EVENT_SEQUENCE_ID_PATH_EDEFAULT.equals(eventSequenceIDPath);
			case MmPackage.INBOUND_EVENT_TYPE__EXTENSION_NAME:
				return EXTENSION_NAME_EDEFAULT == null ? extensionName != null : !EXTENSION_NAME_EDEFAULT.equals(extensionName);
			case MmPackage.INBOUND_EVENT_TYPE__MULTIPLE_CORRELATION_MATCHES:
				return isSetMultipleCorrelationMatches();
			case MmPackage.INBOUND_EVENT_TYPE__NO_CORRELATION_MATCHES:
				return isSetNoCorrelationMatches();
			case MmPackage.INBOUND_EVENT_TYPE__ONE_CORRELATION_MATCH:
				return isSetOneCorrelationMatch();
			case MmPackage.INBOUND_EVENT_TYPE__ROOT_ELEMENT:
				return ROOT_ELEMENT_EDEFAULT == null ? rootElement != null : !ROOT_ELEMENT_EDEFAULT.equals(rootElement);
			case MmPackage.INBOUND_EVENT_TYPE__TERMINATE_CONTEXT:
				return isSetTerminateContext();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (eventSequenceIDPath: ");
		result.append(eventSequenceIDPath);
		result.append(", extensionName: ");
		result.append(extensionName);
		result.append(", multipleCorrelationMatches: ");
		if (multipleCorrelationMatchesESet) result.append(multipleCorrelationMatches); else result.append("<unset>");
		result.append(", noCorrelationMatches: ");
		if (noCorrelationMatchesESet) result.append(noCorrelationMatches); else result.append("<unset>");
		result.append(", oneCorrelationMatch: ");
		if (oneCorrelationMatchESet) result.append(oneCorrelationMatch); else result.append("<unset>");
		result.append(", rootElement: ");
		result.append(rootElement);
		result.append(", terminateContext: ");
		if (terminateContextESet) result.append(terminateContext); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

	/**
	 * This method determines whether this InboundEventType is referencing a 6.0.2-style .CBE event definition
	 * or a set of 6.1+ style XSD event definitions 
	 */
	public boolean hasCBEDefinition(){
		/* If there is an extensionName defined, but no eventParts, we can assume that the reference is to 
		 * a 6.0.2-style CBE event definition */
		return (getExtensionName() != null && getExtensionName().trim().length() > 0);
	}
	
	/**
	 * This method provides access to the CBE event type object referenced by this InboundEventType.  This method 
	 * attempts to resolve the path to the actual event definition in its external file, if possible.  Note that if 
	 * this inbound event does not refer to a .CBE-style event, null is returned.
	 * 
	 * NOTE: This method requires that the InboundEventType object be associated to a Resource and ResourceSet indirectly
	 * via its containment hierarchy.
	 * 
	 * @deprecated
	 * 
	 * @return The event type object or null if the inbound event is not a .CBE style, or cannot be resolved
	 */
	public EObject getEventTypeObject(){
		return getCbeEventObject();
	}
	
	/**
	 * This method provides access to the CBE event type object referenced by this InboundEventType.  This method 
	 * attempts to resolve the path to the actual event definition in its external file, if possible.  Note that if 
	 * this inbound event does not refer to a .CBE-style event, null is returned.
	 * 
	 * NOTE: This method requires that the InboundEventType object be associated to a Resource and ResourceSet indirectly
	 * via its containment hierarchy.
	 * 
	 * @return The event type object or null if the inbound event is not a .CBE style, or cannot be resolved
	 */
	public com.ibm.wbimonitor.xml.model.eventdefinition501.EventDefinitionType getCbeEventObject(){
		if (hasCBEDefinition()){
			return (com.ibm.wbimonitor.xml.model.eventdefinition501.EventDefinitionType)EventTypeResolver.resolve(this, getExtensionName());
		} else {
			return null;
		}
	}
} //InboundEventTypeImpl
