/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */ 
/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.ibm.wbimonitor.xml.model.mm.impl;

import com.ibm.wbimonitor.xml.model.mm.AggregationType;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.wbimonitor.xml.model.mm.KPIAggregatedDefinitionType;
import com.ibm.wbimonitor.xml.model.mm.KPIDateTimeMetricFilterRefType;
import com.ibm.wbimonitor.xml.model.mm.KPIMetricFilterRefType;
import com.ibm.wbimonitor.xml.model.mm.MmPackage;
import com.ibm.wbimonitor.xml.model.mm.ReferenceType;

import com.ibm.wbimonitor.xml.model.mm.VersionAggregationType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>KPI Aggregated Definition Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPIAggregatedDefinitionTypeImpl#getMonitoringContext <em>Monitoring Context</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPIAggregatedDefinitionTypeImpl#getMetric <em>Metric</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPIAggregatedDefinitionTypeImpl#getMetricFilter <em>Metric Filter</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPIAggregatedDefinitionTypeImpl#getDateTimeMetricFilter <em>Date Time Metric Filter</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPIAggregatedDefinitionTypeImpl#getAggregationType <em>Aggregation Type</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPIAggregatedDefinitionTypeImpl#getVersionAggregation <em>Version Aggregation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class KPIAggregatedDefinitionTypeImpl extends EObjectImpl implements KPIAggregatedDefinitionType {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2007.";  //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getMonitoringContext() <em>Monitoring Context</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMonitoringContext()
	 * @generated
	 * @ordered
	 */
	protected ReferenceType monitoringContext = null;

	/**
	 * The cached value of the '{@link #getMetric() <em>Metric</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMetric()
	 * @generated
	 * @ordered
	 */
	protected ReferenceType metric = null;

	/**
	 * The cached value of the '{@link #getMetricFilter() <em>Metric Filter</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMetricFilter()
	 * @generated
	 * @ordered
	 */
	protected EList metricFilter = null;

	/**
	 * The cached value of the '{@link #getDateTimeMetricFilter() <em>Date Time Metric Filter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDateTimeMetricFilter()
	 * @generated
	 * @ordered
	 */
	protected KPIDateTimeMetricFilterRefType dateTimeMetricFilter = null;

	/**
	 * The default value of the '{@link #getAggregationType() <em>Aggregation Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAggregationType()
	 * @generated
	 * @ordered
	 */
	protected static final AggregationType AGGREGATION_TYPE_EDEFAULT = AggregationType.MIN_LITERAL;

	/**
	 * The cached value of the '{@link #getAggregationType() <em>Aggregation Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAggregationType()
	 * @generated
	 * @ordered
	 */
	protected AggregationType aggregationType = AGGREGATION_TYPE_EDEFAULT;

	/**
	 * This is true if the Aggregation Type attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean aggregationTypeESet = false;

	/**
	 * The default value of the '{@link #getVersionAggregation() <em>Version Aggregation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersionAggregation()
	 * @generated
	 * @ordered
	 */
	protected static final VersionAggregationType VERSION_AGGREGATION_EDEFAULT = VersionAggregationType.ALL_VERSIONS_LITERAL;

	/**
	 * The cached value of the '{@link #getVersionAggregation() <em>Version Aggregation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersionAggregation()
	 * @generated
	 * @ordered
	 */
	protected VersionAggregationType versionAggregation = VERSION_AGGREGATION_EDEFAULT;

	/**
	 * This is true if the Version Aggregation attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean versionAggregationESet = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected KPIAggregatedDefinitionTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MmPackage.Literals.KPI_AGGREGATED_DEFINITION_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReferenceType getMonitoringContext() {
		return monitoringContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMonitoringContext(ReferenceType newMonitoringContext, NotificationChain msgs) {
		ReferenceType oldMonitoringContext = monitoringContext;
		monitoringContext = newMonitoringContext;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT, oldMonitoringContext, newMonitoringContext);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMonitoringContext(ReferenceType newMonitoringContext) {
		if (newMonitoringContext != monitoringContext) {
			NotificationChain msgs = null;
			if (monitoringContext != null)
				msgs = ((InternalEObject)monitoringContext).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT, null, msgs);
			if (newMonitoringContext != null)
				msgs = ((InternalEObject)newMonitoringContext).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT, null, msgs);
			msgs = basicSetMonitoringContext(newMonitoringContext, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT, newMonitoringContext, newMonitoringContext));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReferenceType getMetric() {
		return metric;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMetric(ReferenceType newMetric, NotificationChain msgs) {
		ReferenceType oldMetric = metric;
		metric = newMetric;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC, oldMetric, newMetric);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMetric(ReferenceType newMetric) {
		if (newMetric != metric) {
			NotificationChain msgs = null;
			if (metric != null)
				msgs = ((InternalEObject)metric).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC, null, msgs);
			if (newMetric != null)
				msgs = ((InternalEObject)newMetric).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC, null, msgs);
			msgs = basicSetMetric(newMetric, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC, newMetric, newMetric));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getMetricFilter() {
		if (metricFilter == null) {
			metricFilter = new EObjectContainmentEList(KPIMetricFilterRefType.class, this, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC_FILTER);
		}
		return metricFilter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KPIDateTimeMetricFilterRefType getDateTimeMetricFilter() {
		return dateTimeMetricFilter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDateTimeMetricFilter(KPIDateTimeMetricFilterRefType newDateTimeMetricFilter, NotificationChain msgs) {
		KPIDateTimeMetricFilterRefType oldDateTimeMetricFilter = dateTimeMetricFilter;
		dateTimeMetricFilter = newDateTimeMetricFilter;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER, oldDateTimeMetricFilter, newDateTimeMetricFilter);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDateTimeMetricFilter(KPIDateTimeMetricFilterRefType newDateTimeMetricFilter) {
		if (newDateTimeMetricFilter != dateTimeMetricFilter) {
			NotificationChain msgs = null;
			if (dateTimeMetricFilter != null)
				msgs = ((InternalEObject)dateTimeMetricFilter).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER, null, msgs);
			if (newDateTimeMetricFilter != null)
				msgs = ((InternalEObject)newDateTimeMetricFilter).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER, null, msgs);
			msgs = basicSetDateTimeMetricFilter(newDateTimeMetricFilter, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER, newDateTimeMetricFilter, newDateTimeMetricFilter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AggregationType getAggregationType() {
		return aggregationType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAggregationType(AggregationType newAggregationType) {
		AggregationType oldAggregationType = aggregationType;
		aggregationType = newAggregationType == null ? AGGREGATION_TYPE_EDEFAULT : newAggregationType;
		boolean oldAggregationTypeESet = aggregationTypeESet;
		aggregationTypeESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__AGGREGATION_TYPE, oldAggregationType, aggregationType, !oldAggregationTypeESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetAggregationType() {
		AggregationType oldAggregationType = aggregationType;
		boolean oldAggregationTypeESet = aggregationTypeESet;
		aggregationType = AGGREGATION_TYPE_EDEFAULT;
		aggregationTypeESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__AGGREGATION_TYPE, oldAggregationType, AGGREGATION_TYPE_EDEFAULT, oldAggregationTypeESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetAggregationType() {
		return aggregationTypeESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VersionAggregationType getVersionAggregation() {
		return versionAggregation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVersionAggregation(VersionAggregationType newVersionAggregation) {
		VersionAggregationType oldVersionAggregation = versionAggregation;
		versionAggregation = newVersionAggregation == null ? VERSION_AGGREGATION_EDEFAULT : newVersionAggregation;
		boolean oldVersionAggregationESet = versionAggregationESet;
		versionAggregationESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__VERSION_AGGREGATION, oldVersionAggregation, versionAggregation, !oldVersionAggregationESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetVersionAggregation() {
		VersionAggregationType oldVersionAggregation = versionAggregation;
		boolean oldVersionAggregationESet = versionAggregationESet;
		versionAggregation = VERSION_AGGREGATION_EDEFAULT;
		versionAggregationESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__VERSION_AGGREGATION, oldVersionAggregation, VERSION_AGGREGATION_EDEFAULT, oldVersionAggregationESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetVersionAggregation() {
		return versionAggregationESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT:
				return basicSetMonitoringContext(null, msgs);
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC:
				return basicSetMetric(null, msgs);
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC_FILTER:
				return ((InternalEList)getMetricFilter()).basicRemove(otherEnd, msgs);
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER:
				return basicSetDateTimeMetricFilter(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT:
				return getMonitoringContext();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC:
				return getMetric();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC_FILTER:
				return getMetricFilter();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER:
				return getDateTimeMetricFilter();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__AGGREGATION_TYPE:
				return getAggregationType();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__VERSION_AGGREGATION:
				return getVersionAggregation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT:
				setMonitoringContext((ReferenceType)newValue);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC:
				setMetric((ReferenceType)newValue);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC_FILTER:
				getMetricFilter().clear();
				getMetricFilter().addAll((Collection)newValue);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER:
				setDateTimeMetricFilter((KPIDateTimeMetricFilterRefType)newValue);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__AGGREGATION_TYPE:
				setAggregationType((AggregationType)newValue);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__VERSION_AGGREGATION:
				setVersionAggregation((VersionAggregationType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT:
				setMonitoringContext((ReferenceType)null);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC:
				setMetric((ReferenceType)null);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC_FILTER:
				getMetricFilter().clear();
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER:
				setDateTimeMetricFilter((KPIDateTimeMetricFilterRefType)null);
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__AGGREGATION_TYPE:
				unsetAggregationType();
				return;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__VERSION_AGGREGATION:
				unsetVersionAggregation();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__MONITORING_CONTEXT:
				return monitoringContext != null;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC:
				return metric != null;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__METRIC_FILTER:
				return metricFilter != null && !metricFilter.isEmpty();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__DATE_TIME_METRIC_FILTER:
				return dateTimeMetricFilter != null;
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__AGGREGATION_TYPE:
				return isSetAggregationType();
			case MmPackage.KPI_AGGREGATED_DEFINITION_TYPE__VERSION_AGGREGATION:
				return isSetVersionAggregation();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (aggregationType: ");
		if (aggregationTypeESet) result.append(aggregationType); else result.append("<unset>");
		result.append(", versionAggregation: ");
		if (versionAggregationESet) result.append(versionAggregation); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //KPIAggregatedDefinitionTypeImpl