/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */ 
/**
 * <copyright>
 * </copyright>
 *
 * $Id: KPITypeImpl.java,v 1.1 2006/06/27 15:10:33 crmiles Exp $
 */
package com.ibm.wbimonitor.xml.model.mm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.wbimonitor.xml.model.mm.KPIAggregatedDefinitionType;
import com.ibm.wbimonitor.xml.model.mm.KPICalculatedDefinitionType;
import com.ibm.wbimonitor.xml.model.mm.KPIType;
import com.ibm.wbimonitor.xml.model.mm.MmPackage;
import com.ibm.wbimonitor.xml.model.mm.RangeType;
import com.ibm.wbimonitor.xml.model.mm.RangeTypeType;
import com.ibm.wbimonitor.xml.model.mm.TargetValueType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>KPI Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPITypeImpl#getAggregatedDefinition <em>Aggregated Definition</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPITypeImpl#getCalculatedDefinition <em>Calculated Definition</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPITypeImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPITypeImpl#getRange <em>Range</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPITypeImpl#getRangeType <em>Range Type</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.KPITypeImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class KPITypeImpl extends NamedElementTypeImpl implements KPIType {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2007.";  //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getAggregatedDefinition() <em>Aggregated Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAggregatedDefinition()
	 * @generated
	 * @ordered
	 */
	protected KPIAggregatedDefinitionType aggregatedDefinition = null;

	/**
	 * The cached value of the '{@link #getCalculatedDefinition() <em>Calculated Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCalculatedDefinition()
	 * @generated
	 * @ordered
	 */
	protected KPICalculatedDefinitionType calculatedDefinition = null;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected TargetValueType target = null;

	/**
	 * The cached value of the '{@link #getRange() <em>Range</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRange()
	 * @generated
	 * @ordered
	 */
	protected EList range = null;

	/**
	 * The default value of the '{@link #getRangeType() <em>Range Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRangeType()
	 * @generated
	 * @ordered
	 */
	protected static final RangeTypeType RANGE_TYPE_EDEFAULT = RangeTypeType.ACTUAL_VALUE_LITERAL;

	/**
	 * The cached value of the '{@link #getRangeType() <em>Range Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRangeType()
	 * @generated
	 * @ordered
	 */
	protected RangeTypeType rangeType = RANGE_TYPE_EDEFAULT;

	/**
	 * This is true if the Range Type attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean rangeTypeESet = false;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final Object TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected Object type = TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected KPITypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MmPackage.Literals.KPI_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KPIAggregatedDefinitionType getAggregatedDefinition() {
		return aggregatedDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAggregatedDefinition(KPIAggregatedDefinitionType newAggregatedDefinition, NotificationChain msgs) {
		KPIAggregatedDefinitionType oldAggregatedDefinition = aggregatedDefinition;
		aggregatedDefinition = newAggregatedDefinition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__AGGREGATED_DEFINITION, oldAggregatedDefinition, newAggregatedDefinition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAggregatedDefinition(KPIAggregatedDefinitionType newAggregatedDefinition) {
		if (newAggregatedDefinition != aggregatedDefinition) {
			NotificationChain msgs = null;
			if (aggregatedDefinition != null)
				msgs = ((InternalEObject)aggregatedDefinition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_TYPE__AGGREGATED_DEFINITION, null, msgs);
			if (newAggregatedDefinition != null)
				msgs = ((InternalEObject)newAggregatedDefinition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_TYPE__AGGREGATED_DEFINITION, null, msgs);
			msgs = basicSetAggregatedDefinition(newAggregatedDefinition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__AGGREGATED_DEFINITION, newAggregatedDefinition, newAggregatedDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KPICalculatedDefinitionType getCalculatedDefinition() {
		return calculatedDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCalculatedDefinition(KPICalculatedDefinitionType newCalculatedDefinition, NotificationChain msgs) {
		KPICalculatedDefinitionType oldCalculatedDefinition = calculatedDefinition;
		calculatedDefinition = newCalculatedDefinition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__CALCULATED_DEFINITION, oldCalculatedDefinition, newCalculatedDefinition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCalculatedDefinition(KPICalculatedDefinitionType newCalculatedDefinition) {
		if (newCalculatedDefinition != calculatedDefinition) {
			NotificationChain msgs = null;
			if (calculatedDefinition != null)
				msgs = ((InternalEObject)calculatedDefinition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_TYPE__CALCULATED_DEFINITION, null, msgs);
			if (newCalculatedDefinition != null)
				msgs = ((InternalEObject)newCalculatedDefinition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_TYPE__CALCULATED_DEFINITION, null, msgs);
			msgs = basicSetCalculatedDefinition(newCalculatedDefinition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__CALCULATED_DEFINITION, newCalculatedDefinition, newCalculatedDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TargetValueType getTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTarget(TargetValueType newTarget, NotificationChain msgs) {
		TargetValueType oldTarget = target;
		target = newTarget;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__TARGET, oldTarget, newTarget);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTarget(TargetValueType newTarget) {
		if (newTarget != target) {
			NotificationChain msgs = null;
			if (target != null)
				msgs = ((InternalEObject)target).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_TYPE__TARGET, null, msgs);
			if (newTarget != null)
				msgs = ((InternalEObject)newTarget).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.KPI_TYPE__TARGET, null, msgs);
			msgs = basicSetTarget(newTarget, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__TARGET, newTarget, newTarget));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getRange() {
		if (range == null) {
			range = new EObjectContainmentEList(RangeType.class, this, MmPackage.KPI_TYPE__RANGE);
		}
		return range;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RangeTypeType getRangeType() {
		return rangeType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRangeType(RangeTypeType newRangeType) {
		RangeTypeType oldRangeType = rangeType;
		rangeType = newRangeType == null ? RANGE_TYPE_EDEFAULT : newRangeType;
		boolean oldRangeTypeESet = rangeTypeESet;
		rangeTypeESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__RANGE_TYPE, oldRangeType, rangeType, !oldRangeTypeESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetRangeType() {
		RangeTypeType oldRangeType = rangeType;
		boolean oldRangeTypeESet = rangeTypeESet;
		rangeType = RANGE_TYPE_EDEFAULT;
		rangeTypeESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.KPI_TYPE__RANGE_TYPE, oldRangeType, RANGE_TYPE_EDEFAULT, oldRangeTypeESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetRangeType() {
		return rangeTypeESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(Object newType) {
		Object oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.KPI_TYPE__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MmPackage.KPI_TYPE__AGGREGATED_DEFINITION:
				return basicSetAggregatedDefinition(null, msgs);
			case MmPackage.KPI_TYPE__CALCULATED_DEFINITION:
				return basicSetCalculatedDefinition(null, msgs);
			case MmPackage.KPI_TYPE__TARGET:
				return basicSetTarget(null, msgs);
			case MmPackage.KPI_TYPE__RANGE:
				return ((InternalEList)getRange()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MmPackage.KPI_TYPE__AGGREGATED_DEFINITION:
				return getAggregatedDefinition();
			case MmPackage.KPI_TYPE__CALCULATED_DEFINITION:
				return getCalculatedDefinition();
			case MmPackage.KPI_TYPE__TARGET:
				return getTarget();
			case MmPackage.KPI_TYPE__RANGE:
				return getRange();
			case MmPackage.KPI_TYPE__RANGE_TYPE:
				return getRangeType();
			case MmPackage.KPI_TYPE__TYPE:
				return getType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MmPackage.KPI_TYPE__AGGREGATED_DEFINITION:
				setAggregatedDefinition((KPIAggregatedDefinitionType)newValue);
				return;
			case MmPackage.KPI_TYPE__CALCULATED_DEFINITION:
				setCalculatedDefinition((KPICalculatedDefinitionType)newValue);
				return;
			case MmPackage.KPI_TYPE__TARGET:
				setTarget((TargetValueType)newValue);
				return;
			case MmPackage.KPI_TYPE__RANGE:
				getRange().clear();
				getRange().addAll((Collection)newValue);
				return;
			case MmPackage.KPI_TYPE__RANGE_TYPE:
				setRangeType((RangeTypeType)newValue);
				return;
			case MmPackage.KPI_TYPE__TYPE:
				setType((Object)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case MmPackage.KPI_TYPE__AGGREGATED_DEFINITION:
				setAggregatedDefinition((KPIAggregatedDefinitionType)null);
				return;
			case MmPackage.KPI_TYPE__CALCULATED_DEFINITION:
				setCalculatedDefinition((KPICalculatedDefinitionType)null);
				return;
			case MmPackage.KPI_TYPE__TARGET:
				setTarget((TargetValueType)null);
				return;
			case MmPackage.KPI_TYPE__RANGE:
				getRange().clear();
				return;
			case MmPackage.KPI_TYPE__RANGE_TYPE:
				unsetRangeType();
				return;
			case MmPackage.KPI_TYPE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MmPackage.KPI_TYPE__AGGREGATED_DEFINITION:
				return aggregatedDefinition != null;
			case MmPackage.KPI_TYPE__CALCULATED_DEFINITION:
				return calculatedDefinition != null;
			case MmPackage.KPI_TYPE__TARGET:
				return target != null;
			case MmPackage.KPI_TYPE__RANGE:
				return range != null && !range.isEmpty();
			case MmPackage.KPI_TYPE__RANGE_TYPE:
				return isSetRangeType();
			case MmPackage.KPI_TYPE__TYPE:
				return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (rangeType: ");
		if (rangeTypeESet) result.append(rangeType); else result.append("<unset>");
		result.append(", type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //KPITypeImpl
