/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2006, 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.wbimonitor.xml.model.util;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import com.ibm.wbimonitor.xml.model.ModelPlugin;

public class Logger {
public static final String COPYRIGHT="(C) Copyright IBM Corporation 2006, 2007.";  //$NON-NLS-1$


	public static void log(String message){
		log(IStatus.ERROR, message);
	}

	public static void log(int severity, String message){
		log(severity, message, null);
	}

	public static void log( int severity, String message, Exception e){
		ModelPlugin.getDefault().getLog().log(
				new Status(severity,
						   ModelPlugin.getDefault().getBundle().getSymbolicName(),
						   0, 			// code
						   (message == null ? "" : message),
						   e));
	}

}