<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%--BEGIN CMVC --%>
<%--***********************************************************************************--%>
<%--                                                                                   --%>
<%--  Workfile: SOACORE/ws/code/cbebrowser/CBEBrowserWeb/jsp/viewer/CBEBrowserBanner.jsp, wbi.cbebrowser, WASX.SOACORE                                                                    --%>
<%--  Last update: 07/01/18 04:32:46                                                             --%>
<%--  SCCS path, id: /family/botp/vc/8/4/4/5/s.69 1.11.1.1                                                           --%>
<%--                                                                                   --%>
<%--***********************************************************************************--%>
<%--END CMVC --%>
<%
//BEGIN COPYRIGHT
//*************************************************************************
//
//	Licensed Materials - Property of IBM
//	5724-L01, 5655-N53, 5724-I82, 5655-R15
//	- Copyright IBM Corporation 2005,2007. All Rights Reserved.
//	US Government Users Restricted Rights- Use, duplication or disclosure
//	restricted by GSA ADP Schedule Contract with IBM Corp.
//
//*************************************************************************
//END COPYRIGHT
%>
<%@ page contentType="text/html;charset=UTF-8" %>

<%@ taglib uri="/WEB-INF/tld/WCLTagLib.tld" prefix="wcl" %>

<%@ page import="com.ibm.wbiserver.cbebrowser.CBEBrowserNlsUtilities"%>
<%@ page import="com.ibm.wbiserver.cbebrowser.ICBEBrowserNlsConstants"%>
<%@ page import="com.ibm.wbiserver.cbebrowser.ui.ICBEBrowserConstants"%>

<!-- Obtain translated strings up front
-->

<%
String helpUrl=null;
java.util.Locale locale = request.getLocale();
String contextPath = request.getContextPath();
String cbebrowserlogoUrl = "url(" + contextPath + "/resources/images/ws_banner_EventBrowser" + CBEBrowserNlsUtilities.getNLSPrefix(locale) + ".jpg)";
String cbebrowserlogoString = CBEBrowserNlsUtilities.getNonMessageString( locale, "ALTTEXT.CBEBROWSERLOGO" );
String ibmlogoUrl = contextPath + "/resources/images/ibm_logo.jpg";
String ibmlogoString = CBEBrowserNlsUtilities.getNonMessageString( locale, "ALTTEXT.IBMLOGO" );
String dividerString = "&nbsp;&nbsp; | &nbsp;&nbsp;";
String geteventsString = CBEBrowserNlsUtilities.getNonMessageString( locale, "HYPERLINKTEXT.BANNER.GETEVENTS" );
String geteventsUrl = contextPath + "/events?view=getevents";
String logoutString = CBEBrowserNlsUtilities.getNonMessageString( locale, "HYPERLINKTEXT.BANNER.LOGOUT" );
String logoutUrl = "ibm_security_logout?logout=Logout&logoutExitPage=";

String helpString = CBEBrowserNlsUtilities.getNonMessageString( locale, "HYPERLINKTEXT.BANNER.HELP" );
String lang_Locale = locale.toString();
String lang = locale.getLanguage();
if (lang_Locale.equals("en_US")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_EN" );
}
else if(lang_Locale.equals("fr")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_FR" );
}
else if(lang_Locale.equals("ko")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_KO" );
}

else if(lang_Locale.equals("it")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_IT" );
}

else if(lang_Locale.equals("ja")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_JA" );
}

else if(lang_Locale.equals("de")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_DE" );
}

else if(lang_Locale.equals("pt_BR")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_PTBR" );
}

else if(lang_Locale.equals("es")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_ES" );
}

else if((lang_Locale.equals("zh")) || (lang_Locale.equals("zh_CN"))){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_ZH" );
}

else if(lang_Locale.equals("zh_TW")){
   helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_ZHTW" );
}

else if(lang_Locale.equals("pl")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_PL" );
}

else if(lang_Locale.equals("cs")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_CS" );
}

else if(lang_Locale.equals("ru")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_RU" );
}

else if(lang_Locale.equals("hu")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_HU" );
}

else if(lang_Locale.equals("ar")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_AR" );
}

else if(lang_Locale.equals("he")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_HE" );
}

else if(lang_Locale.equals("iw")){
    helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_IW" );
}

else {
		if (lang.equals("en")){
   	  		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_EN" );
	  	}
		else if(lang.equals("fr")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_FR" );
		}
		else if(lang.equals("ko")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_KO" );
		}
		else if(lang.equals("it")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_IT" );
		}
		else if(lang.equals("ja")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_JA" );
		}
		else if(lang.equals("de")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_DE" );
		}
		else if(lang.equals("pt")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_PTBR" );
		}
		else if(lang.equals("es")){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_ES" );
		}
		else if((lang.equals("zh"))){
   			helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_ZH" );
		}
		else if(lang.equals("pl")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_PL" );
		}
		else if(lang.equals("cs")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_CS" );
		}
		else if(lang.equals("ru")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_RU" );
		}
		else if(lang.equals("hu")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_HU" );
		}
		else if(lang.equals("ar")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_AR" );
		}
		else if(lang.equals("he")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_HE" );
		}
		else if(lang.equals("iw")){
    		helpUrl = contextPath + CBEBrowserNlsUtilities.getString( ICBEBrowserNlsConstants.RESOURCE_BUNDLE_TEXT, locale, "HELPURL.VIEWERPAGES_IW" );
		}
		else{
       		helpUrl = contextPath + "/help/en/ucbe_getEvents.html";
       	}
}
 
String useridName = (String)session.getAttribute( ICBEBrowserConstants.SESSATTR_USERNAME );
String useridString = ( useridName != null ? CBEBrowserNlsUtilities.getNonMessageString( locale, "TEXT.BANNER.USERID", new Object[] { useridName } ) : null );

if (session.getAttribute(ICBEBrowserConstants.SESSATTR_WCL_FACADE )==null )
{
StringBuffer url = request.getRequestURL();
    String logoff_url;
    int index_CBE = url.lastIndexOf("cbebrowser/");
    if (index_CBE >= 0){
	if ( useridName == null ){
	    logoff_url = url.substring(0, index_CBE)+"logoff.do";
	}else{
	    logoff_url = url.substring(0, url.lastIndexOf("cbebrowser/"))+"cbebrowser/jsp/logon/CBEBrowserLogonMain.jsp";
	}
%>

<html>
<SCRIPT language="javascript">
function load(logoff_url) {
window.open(logoff_url, "_parent", true);
}
</SCRIPT>
</HEAD>
<BODY dir=LTR onLoad="load('<%=logoff_url%>')">
</BODY>
</html>
<%
    }
}else{
%>
<!--
** This is the page that holds the banner and the toolbar.
** This view jsp is driven by the CBEBrowserEventsServlet modeller and controller.
-->



<wcl:Foundation
  objectScope="session"
  pageName="<%=ICBEBrowserConstants.PAGENAME_BANNER%>"
  wclFacadeScope="session"
  wclFacadeScopeId="<%=ICBEBrowserConstants.SESSATTR_WCL_FACADE%>">

  <HTML>

    <HEAD dir=LTR>
      <LINK HREF="<%=request.getContextPath()%>/resources/css/style.css" REL="stylesheet" type="text/css">
    </HEAD>

    <BODY dir=LTR>

      <wcl:WBoxLayout
        objectScopeId="<%=ICBEBrowserConstants.LAYOUTNAME_BANNER_VERT%>"
        orientation="vertical"
        gap="0"
        componentOrientation="ltr"
        >

        <wcl:StyleInfo
          className="com.ibm.psw.wcl.skins.base.BaseSimpleLayoutStyleInfo">
          <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_SIMPLE_LAYOUT%>" attribute="background" value="<%=cbebrowserlogoUrl%>"/>
          <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_SIMPLE_LAYOUT%>" attribute="title" value="<%=cbebrowserlogoString%>"/>
        </wcl:StyleInfo>

        <wcl:WBoxLayoutCell align="right"><IMG src="<%=ibmlogoUrl%>" alt="<%=ibmlogoString%>" width="112" height="53"/></wcl:WBoxLayoutCell>

        <wcl:WBoxLayoutCell>

          <wcl:WBoxLayout
            objectScopeId="<%=ICBEBrowserConstants.LAYOUTNAME_BANNER_TOOLBAR%>"
            orientation="horizontal"
            width="100%"
            gap="0"
            componentOrientation="ltr">

            <wcl:StyleInfo
              className="com.ibm.psw.wcl.skins.base.BaseContainerStyleInfo">
              <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_SIMPLE_LAYOUT%>" attribute="background-color" value="#ADB0EC"/>
              <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_SIMPLE_LAYOUT%>" attribute="padding-left" value="10px"/>
              <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_SIMPLE_LAYOUT%>" attribute="padding-right" value="10px"/>
            </wcl:StyleInfo>

            <wcl:WBoxLayoutCell
              align="left">

              <wcl:WBoxLayout
                objectScopeId="<%=ICBEBrowserConstants.LAYOUTNAME_BANNER_TOOLBARLEFT%>"
                orientation="horizontal"
                width="null"
                gap="3"
                componentOrientation="ltr">

                <wcl:WBoxLayoutCell>

                  <wcl:WHyperlink
                    objectScopeId="<%=ICBEBrowserConstants.HYPERLINK_BANNER_GETEVENTS%>"
                    target="<%=ICBEBrowserConstants.FRAMENAME_VIEW%>"
                    url="<%=geteventsUrl%>"
                    text="<%=geteventsString%>">
                    <wcl:StyleInfo className="com.ibm.psw.wcl.skins.base.BaseHyperlinkStyleInfo">
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="color" value="black"/>
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="font-weight" value="bold"/>
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="font-size" value="70.0%"/>
                    </wcl:StyleInfo>
                  </wcl:WHyperlink>

                </wcl:WBoxLayoutCell>

<%
if ( useridName != null )
{
%>

                <wcl:WBoxLayoutCell>

                  <wcl:WContainer objectScopeId="<%=ICBEBrowserConstants.DIVIDER_BANNER_1%>"
                  componentOrientation="ltr">

                    <DIV dir=LTR class="top-banner-divider"><%=dividerString%></DIV>

                  </wcl:WContainer>

                </wcl:WBoxLayoutCell>

                <wcl:WBoxLayoutCell>

                  <wcl:WHyperlink
                    objectScopeId="<%=ICBEBrowserConstants.HYPERLINK_BANNER_LOGOUT%>"
                    target="_top"
                    url="<%=logoutUrl%>"
                    text="<%=logoutString%>">
                    <wcl:StyleInfo className="com.ibm.psw.wcl.skins.base.BaseHyperlinkStyleInfo">
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="color" value="black"/>
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="font-weight" value="bold"/>
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="font-size" value="70.0%"/>
                    </wcl:StyleInfo>
                  </wcl:WHyperlink>

                </wcl:WBoxLayoutCell>

<%
}
%>

                <wcl:WBoxLayoutCell>

                  <wcl:WContainer objectScopeId="<%=ICBEBrowserConstants.DIVIDER_BANNER_2%>"
                  componentOrientation="ltr">

                    <DIV dir=LTR class="top-banner-divider"><%=dividerString%></DIV>

                  </wcl:WContainer>

                </wcl:WBoxLayoutCell>

                <wcl:WBoxLayoutCell>

                  <wcl:WHyperlink
                    objectScopeId="<%=ICBEBrowserConstants.HYPERLINK_BANNER_HELP%>"
                    target="_blank"
                    url="<%=helpUrl%>"
                    text="<%=helpString%>">
                    <wcl:StyleInfo className="com.ibm.psw.wcl.skins.base.BaseHyperlinkStyleInfo">
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="color" value="black"/>
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="font-weight" value="bold"/>
                      <wcl:StyleValue descriptorId="<%=com.ibm.psw.wcl.core.skin.ISkinConstants.ID_HYPERLINK%>" attribute="font-size" value="70.0%"/>
                    </wcl:StyleInfo>
                  </wcl:WHyperlink>

                </wcl:WBoxLayoutCell>

                <wcl:WBoxLayoutCell>

                  <wcl:WContainer objectScopeId="<%=ICBEBrowserConstants.DIVIDER_BANNER_3%>"
                  componentOrientation="ltr">

                    <DIV dir=LTR class="top-banner-divider"><%=dividerString%></DIV>

                  </wcl:WContainer>

                </wcl:WBoxLayoutCell>

              </wcl:WBoxLayout>

            </wcl:WBoxLayoutCell>

<%
if ( useridName != null )
{
%>

            <wcl:WBoxLayoutCell
              align="right">

              <wcl:WBoxLayout
                objectScopeId="<%=ICBEBrowserConstants.LAYOUTNAME_BANNER_TOOLBARRIGHT%>"
                orientation="horizontal"
                width="null"
                gap="3"
                componentOrientation="ltr"
                >

                <wcl:WBoxLayoutCell>

                  <wcl:WContainer objectScopeId="<%=ICBEBrowserConstants.TEXT_BANNER_USERID%>"
                  componentOrientation="ltr">

                    <DIV dir=LTR class="top-banner-text"><%=useridString%></DIV>

                  </wcl:WContainer>

                </wcl:WBoxLayoutCell>

                <wcl:WBoxLayoutCell>

                  <wcl:WContainer objectScopeId="<%=ICBEBrowserConstants.SPACE_BANNER_1%>"
                  componentOrientation="ltr">

                    <DIV dir=LTR class="top-banner-text">&nbsp;&nbsp;&nbsp;&nbsp;</DIV>

                  </wcl:WContainer>

                </wcl:WBoxLayoutCell>

              </wcl:WBoxLayout>

            </wcl:WBoxLayoutCell>

<%
}
%>

          </wcl:WBoxLayout>

        </wcl:WBoxLayoutCell>

      </wcl:WBoxLayout>

    </BODY>

  </HTML>

</wcl:Foundation>

<%
}
%>
