/* 
  Licensed Materials - Property of IBM
  5655-FLW,5724-M24 (C) Copyright IBM Corporation 2007. All Rights Reserved.
  US Government Users Restricted Rights- Use, duplication or disclosure
*/
WScript.StdOut.WriteLine(">> starting profileShortCut2StartMenuNDDefaultWBMServer.js");

var wshShell = WScript.createobject("WScript.Shell");
var fileObject = WScript.createobject("Scripting.FileSystemObject");

var startMenuLocation = wshShell.SpecialFolders("Programs");
WScript.StdOut.WriteLine("StartMenu Location = " + startMenuLocation);

var forReading = 1;
var tristateUseDefault = -2;
var txtFilePath = "${WASROOT}\\properties\\version\\install.wbm\\config\\install\\productShortCut2StartMenuWBM.txt";
var f = fileObject.GetFile(txtFilePath);
var ts = f.OpenAsTextStream(forReading, tristateUseDefault);
var icounter = ts.ReadLine();
ts.Close();

var scounter;
if (icounter == 0)
      scounter = "";
else
      scounter = " (" + icounter + ")";

WScript.StdOut.WriteLine("counter value = '" + scounter + "'");
      
// Get OS version. Ver 6 = Win Vista
var env = wshShell.Environment;
var osid = env("PROCESSOR_IDENTIFIER");
var osver = osid.charAt(osid.indexOf("Family") + 7);
WScript.StdOut.WriteLine("OS ID = " + osid + " ==> ver = " + osver);
      
// Get path to IE. Vista has different registry path
var key = "HKEY_LOCAL_MACHINE\\";
var iePath = "";
if (osver == 6)
	iePath = wshShell.RegRead(key + "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\IEXPLORE.EXE\\");
else
    iePath = wshShell.RegRead(key + "SOFTWARE\\Microsoft\\IE Setup\\Setup\\Path") + "\\IEXPLORE.EXE";
    
WScript.StdOut.WriteLine("IE Path = " + iePath);

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM WebSphere")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM WebSphere");

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter)))
      fileObject.CreateFolder(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter);      

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1"  + scounter + "\\${PROFILES}")))      
      fileObject.CreateFolder(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1"  + scounter + "\\${PROFILES}");
            
if (!(fileObject.FolderExists(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1"  + scounter + "\\${PROFILES}\\${PROFILENAME}")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1"  + scounter + "\\${PROFILES}\\${PROFILENAME}");

var objShellLinkFirstSteps = wshShell.CreateShortcut(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1"  + scounter + "\\${PROFILES}\\${PROFILENAME}\\${FIRSTSTEPS}.lnk");

//1: Activates and displays a window. If the window is minimized or maximized, the system restores it to its original size and position. 
//3: Activates the window and displays it as a maximized window.  
//7: Minimizes the window and activates the next top-level window. 
objShellLinkFirstSteps.WindowStyle = 7;

objShellLinkFirstSteps.IconLocation = "${WASROOT}\\bin\\icons\\firststeps.ico";
objShellLinkFirstSteps.TargetPath = "${PROFILEROOT}\\firststeps.wbm\\firststeps.bat";
objShellLinkFirstSteps.WorkingDirectory = "${PROFILEROOT}\\firststeps.wbm";
objShellLinkFirstSteps.Description = "${FIRSTSTEPS}";
objShellLinkFirstSteps.Save(); //commit change

WScript.StdOut.WriteLine("<< ending profileShortCut2StartMenuCustomWBMServer.js");
