/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */ 
/**
 * <copyright>
 * </copyright>
 *
 * $Id: MonitorTypeImpl.java,v 1.1 2006/06/27 15:10:41 crmiles Exp $
 */
package com.ibm.wbimonitor.xml.model.mm.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import com.ibm.wbimonitor.xml.model.mm.DimensionalModelType;
import com.ibm.wbimonitor.xml.model.mm.EventModelType;
import com.ibm.wbimonitor.xml.model.mm.KPIModelType;
import com.ibm.wbimonitor.xml.model.mm.MmPackage;
import com.ibm.wbimonitor.xml.model.mm.MonitorDetailsModelType;
import com.ibm.wbimonitor.xml.model.mm.MonitorType;
import com.ibm.wbimonitor.xml.model.mm.VisualModelType;
import com.ibm.wbimonitor.xml.model.mm.XPathFunctionsType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Monitor Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getXpathFunctions <em>Xpath Functions</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getMonitorDetailsModel <em>Monitor Details Model</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getKpiModel <em>Kpi Model</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getDimensionalModel <em>Dimensional Model</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getVisualModel <em>Visual Model</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getEventModel <em>Event Model</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getTargetNamespace <em>Target Namespace</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.MonitorTypeImpl#getTimestamp <em>Timestamp</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MonitorTypeImpl extends NamedElementTypeImpl implements MonitorType {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2007.";  //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getXpathFunctions() <em>Xpath Functions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXpathFunctions()
	 * @generated
	 * @ordered
	 */
	protected XPathFunctionsType xpathFunctions = null;

	/**
	 * The cached value of the '{@link #getMonitorDetailsModel() <em>Monitor Details Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMonitorDetailsModel()
	 * @generated
	 * @ordered
	 */
	protected MonitorDetailsModelType monitorDetailsModel = null;

	/**
	 * The cached value of the '{@link #getKpiModel() <em>Kpi Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKpiModel()
	 * @generated
	 * @ordered
	 */
	protected KPIModelType kpiModel = null;

	/**
	 * The cached value of the '{@link #getDimensionalModel() <em>Dimensional Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDimensionalModel()
	 * @generated
	 * @ordered
	 */
	protected DimensionalModelType dimensionalModel = null;

	/**
	 * The cached value of the '{@link #getVisualModel() <em>Visual Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVisualModel()
	 * @generated
	 * @ordered
	 */
	protected VisualModelType visualModel = null;

	/**
	 * The cached value of the '{@link #getEventModel() <em>Event Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventModel()
	 * @generated
	 * @ordered
	 */
	protected EventModelType eventModel = null;

	/**
	 * The default value of the '{@link #getTargetNamespace() <em>Target Namespace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetNamespace()
	 * @generated
	 * @ordered
	 */
	protected static final String TARGET_NAMESPACE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTargetNamespace() <em>Target Namespace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetNamespace()
	 * @generated
	 * @ordered
	 */
	protected String targetNamespace = TARGET_NAMESPACE_EDEFAULT;

	/**
	 * The default value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimestamp()
	 * @generated
	 * @ordered
	 */
	protected static final String TIMESTAMP_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimestamp()
	 * @generated
	 * @ordered
	 */
	protected String timestamp = TIMESTAMP_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MonitorTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MmPackage.Literals.MONITOR_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XPathFunctionsType getXpathFunctions() {
		return xpathFunctions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetXpathFunctions(XPathFunctionsType newXpathFunctions, NotificationChain msgs) {
		XPathFunctionsType oldXpathFunctions = xpathFunctions;
		xpathFunctions = newXpathFunctions;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS, oldXpathFunctions, newXpathFunctions);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setXpathFunctions(XPathFunctionsType newXpathFunctions) {
		if (newXpathFunctions != xpathFunctions) {
			NotificationChain msgs = null;
			if (xpathFunctions != null)
				msgs = ((InternalEObject)xpathFunctions).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS, null, msgs);
			if (newXpathFunctions != null)
				msgs = ((InternalEObject)newXpathFunctions).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS, null, msgs);
			msgs = basicSetXpathFunctions(newXpathFunctions, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS, newXpathFunctions, newXpathFunctions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MonitorDetailsModelType getMonitorDetailsModel() {
		return monitorDetailsModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMonitorDetailsModel(MonitorDetailsModelType newMonitorDetailsModel, NotificationChain msgs) {
		MonitorDetailsModelType oldMonitorDetailsModel = monitorDetailsModel;
		monitorDetailsModel = newMonitorDetailsModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL, oldMonitorDetailsModel, newMonitorDetailsModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMonitorDetailsModel(MonitorDetailsModelType newMonitorDetailsModel) {
		if (newMonitorDetailsModel != monitorDetailsModel) {
			NotificationChain msgs = null;
			if (monitorDetailsModel != null)
				msgs = ((InternalEObject)monitorDetailsModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL, null, msgs);
			if (newMonitorDetailsModel != null)
				msgs = ((InternalEObject)newMonitorDetailsModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL, null, msgs);
			msgs = basicSetMonitorDetailsModel(newMonitorDetailsModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL, newMonitorDetailsModel, newMonitorDetailsModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KPIModelType getKpiModel() {
		return kpiModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetKpiModel(KPIModelType newKpiModel, NotificationChain msgs) {
		KPIModelType oldKpiModel = kpiModel;
		kpiModel = newKpiModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__KPI_MODEL, oldKpiModel, newKpiModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setKpiModel(KPIModelType newKpiModel) {
		if (newKpiModel != kpiModel) {
			NotificationChain msgs = null;
			if (kpiModel != null)
				msgs = ((InternalEObject)kpiModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__KPI_MODEL, null, msgs);
			if (newKpiModel != null)
				msgs = ((InternalEObject)newKpiModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__KPI_MODEL, null, msgs);
			msgs = basicSetKpiModel(newKpiModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__KPI_MODEL, newKpiModel, newKpiModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DimensionalModelType getDimensionalModel() {
		return dimensionalModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDimensionalModel(DimensionalModelType newDimensionalModel, NotificationChain msgs) {
		DimensionalModelType oldDimensionalModel = dimensionalModel;
		dimensionalModel = newDimensionalModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL, oldDimensionalModel, newDimensionalModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDimensionalModel(DimensionalModelType newDimensionalModel) {
		if (newDimensionalModel != dimensionalModel) {
			NotificationChain msgs = null;
			if (dimensionalModel != null)
				msgs = ((InternalEObject)dimensionalModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL, null, msgs);
			if (newDimensionalModel != null)
				msgs = ((InternalEObject)newDimensionalModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL, null, msgs);
			msgs = basicSetDimensionalModel(newDimensionalModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL, newDimensionalModel, newDimensionalModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VisualModelType getVisualModel() {
		return visualModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetVisualModel(VisualModelType newVisualModel, NotificationChain msgs) {
		VisualModelType oldVisualModel = visualModel;
		visualModel = newVisualModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__VISUAL_MODEL, oldVisualModel, newVisualModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVisualModel(VisualModelType newVisualModel) {
		if (newVisualModel != visualModel) {
			NotificationChain msgs = null;
			if (visualModel != null)
				msgs = ((InternalEObject)visualModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__VISUAL_MODEL, null, msgs);
			if (newVisualModel != null)
				msgs = ((InternalEObject)newVisualModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__VISUAL_MODEL, null, msgs);
			msgs = basicSetVisualModel(newVisualModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__VISUAL_MODEL, newVisualModel, newVisualModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventModelType getEventModel() {
		return eventModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEventModel(EventModelType newEventModel, NotificationChain msgs) {
		EventModelType oldEventModel = eventModel;
		eventModel = newEventModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__EVENT_MODEL, oldEventModel, newEventModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventModel(EventModelType newEventModel) {
		if (newEventModel != eventModel) {
			NotificationChain msgs = null;
			if (eventModel != null)
				msgs = ((InternalEObject)eventModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__EVENT_MODEL, null, msgs);
			if (newEventModel != null)
				msgs = ((InternalEObject)newEventModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.MONITOR_TYPE__EVENT_MODEL, null, msgs);
			msgs = basicSetEventModel(newEventModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__EVENT_MODEL, newEventModel, newEventModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTargetNamespace() {
		return targetNamespace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTargetNamespace(String newTargetNamespace) {
		String oldTargetNamespace = targetNamespace;
		targetNamespace = newTargetNamespace;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__TARGET_NAMESPACE, oldTargetNamespace, targetNamespace));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTimestamp() {
		return timestamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTimestamp(String newTimestamp) {
		String oldTimestamp = timestamp;
		timestamp = newTimestamp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.MONITOR_TYPE__TIMESTAMP, oldTimestamp, timestamp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS:
				return basicSetXpathFunctions(null, msgs);
			case MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL:
				return basicSetMonitorDetailsModel(null, msgs);
			case MmPackage.MONITOR_TYPE__KPI_MODEL:
				return basicSetKpiModel(null, msgs);
			case MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL:
				return basicSetDimensionalModel(null, msgs);
			case MmPackage.MONITOR_TYPE__VISUAL_MODEL:
				return basicSetVisualModel(null, msgs);
			case MmPackage.MONITOR_TYPE__EVENT_MODEL:
				return basicSetEventModel(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS:
				return getXpathFunctions();
			case MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL:
				return getMonitorDetailsModel();
			case MmPackage.MONITOR_TYPE__KPI_MODEL:
				return getKpiModel();
			case MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL:
				return getDimensionalModel();
			case MmPackage.MONITOR_TYPE__VISUAL_MODEL:
				return getVisualModel();
			case MmPackage.MONITOR_TYPE__EVENT_MODEL:
				return getEventModel();
			case MmPackage.MONITOR_TYPE__TARGET_NAMESPACE:
				return getTargetNamespace();
			case MmPackage.MONITOR_TYPE__TIMESTAMP:
				return getTimestamp();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS:
				setXpathFunctions((XPathFunctionsType)newValue);
				return;
			case MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL:
				setMonitorDetailsModel((MonitorDetailsModelType)newValue);
				return;
			case MmPackage.MONITOR_TYPE__KPI_MODEL:
				setKpiModel((KPIModelType)newValue);
				return;
			case MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL:
				setDimensionalModel((DimensionalModelType)newValue);
				return;
			case MmPackage.MONITOR_TYPE__VISUAL_MODEL:
				setVisualModel((VisualModelType)newValue);
				return;
			case MmPackage.MONITOR_TYPE__EVENT_MODEL:
				setEventModel((EventModelType)newValue);
				return;
			case MmPackage.MONITOR_TYPE__TARGET_NAMESPACE:
				setTargetNamespace((String)newValue);
				return;
			case MmPackage.MONITOR_TYPE__TIMESTAMP:
				setTimestamp((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS:
				setXpathFunctions((XPathFunctionsType)null);
				return;
			case MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL:
				setMonitorDetailsModel((MonitorDetailsModelType)null);
				return;
			case MmPackage.MONITOR_TYPE__KPI_MODEL:
				setKpiModel((KPIModelType)null);
				return;
			case MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL:
				setDimensionalModel((DimensionalModelType)null);
				return;
			case MmPackage.MONITOR_TYPE__VISUAL_MODEL:
				setVisualModel((VisualModelType)null);
				return;
			case MmPackage.MONITOR_TYPE__EVENT_MODEL:
				setEventModel((EventModelType)null);
				return;
			case MmPackage.MONITOR_TYPE__TARGET_NAMESPACE:
				setTargetNamespace(TARGET_NAMESPACE_EDEFAULT);
				return;
			case MmPackage.MONITOR_TYPE__TIMESTAMP:
				setTimestamp(TIMESTAMP_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MmPackage.MONITOR_TYPE__XPATH_FUNCTIONS:
				return xpathFunctions != null;
			case MmPackage.MONITOR_TYPE__MONITOR_DETAILS_MODEL:
				return monitorDetailsModel != null;
			case MmPackage.MONITOR_TYPE__KPI_MODEL:
				return kpiModel != null;
			case MmPackage.MONITOR_TYPE__DIMENSIONAL_MODEL:
				return dimensionalModel != null;
			case MmPackage.MONITOR_TYPE__VISUAL_MODEL:
				return visualModel != null;
			case MmPackage.MONITOR_TYPE__EVENT_MODEL:
				return eventModel != null;
			case MmPackage.MONITOR_TYPE__TARGET_NAMESPACE:
				return TARGET_NAMESPACE_EDEFAULT == null ? targetNamespace != null : !TARGET_NAMESPACE_EDEFAULT.equals(targetNamespace);
			case MmPackage.MONITOR_TYPE__TIMESTAMP:
				return TIMESTAMP_EDEFAULT == null ? timestamp != null : !TIMESTAMP_EDEFAULT.equals(timestamp);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (targetNamespace: ");
		result.append(targetNamespace);
		result.append(", timestamp: ");
		result.append(timestamp);
		result.append(')');
		return result.toString();
	}

} //MonitorTypeImpl
