/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */ 
/**
 * <copyright>
 * </copyright>
 *
 * $Id: OutboundEventTypeImpl.java,v 1.1 2006/06/27 15:10:39 crmiles Exp $
 */
package com.ibm.wbimonitor.xml.model.mm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.wbimonitor.xml.model.mm.EventPartType;
import com.ibm.wbimonitor.xml.model.mm.ExpressionSpecificationType;
import com.ibm.wbimonitor.xml.model.mm.MapType;
import com.ibm.wbimonitor.xml.model.mm.MmPackage;
import com.ibm.wbimonitor.xml.model.mm.OutboundEventType;
import com.ibm.wbimonitor.xml.model.mm.util.EventTypeResolver;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Outbound Event Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.OutboundEventTypeImpl#getEventPart <em>Event Part</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.OutboundEventTypeImpl#getMap <em>Map</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.OutboundEventTypeImpl#getFilter <em>Filter</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.OutboundEventTypeImpl#getExtensionName <em>Extension Name</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.OutboundEventTypeImpl#getRootElement <em>Root Element</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class OutboundEventTypeImpl extends NamedElementTypeImpl implements OutboundEventType {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2007.";  //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getEventPart() <em>Event Part</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventPart()
	 * @generated
	 * @ordered
	 */
	protected EList eventPart = null;

	/**
	 * The cached value of the '{@link #getMap() <em>Map</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMap()
	 * @generated
	 * @ordered
	 */
	protected EList map = null;

	/**
	 * The cached value of the '{@link #getFilter() <em>Filter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFilter()
	 * @generated
	 * @ordered
	 */
	protected ExpressionSpecificationType filter = null;

	/**
	 * The default value of the '{@link #getExtensionName() <em>Extension Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensionName()
	 * @generated
	 * @ordered
	 */
	protected static final String EXTENSION_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getExtensionName() <em>Extension Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExtensionName()
	 * @generated
	 * @ordered
	 */
	protected String extensionName = EXTENSION_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getRootElement() <em>Root Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRootElement()
	 * @generated
	 * @ordered
	 */
	protected static final Object ROOT_ELEMENT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getRootElement() <em>Root Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRootElement()
	 * @generated
	 * @ordered
	 */
	protected Object rootElement = ROOT_ELEMENT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OutboundEventTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MmPackage.Literals.OUTBOUND_EVENT_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getEventPart() {
		if (eventPart == null) {
			eventPart = new EObjectContainmentEList(EventPartType.class, this, MmPackage.OUTBOUND_EVENT_TYPE__EVENT_PART);
		}
		return eventPart;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getMap() {
		if (map == null) {
			map = new EObjectContainmentEList(MapType.class, this, MmPackage.OUTBOUND_EVENT_TYPE__MAP);
		}
		return map;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpressionSpecificationType getFilter() {
		return filter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFilter(ExpressionSpecificationType newFilter, NotificationChain msgs) {
		ExpressionSpecificationType oldFilter = filter;
		filter = newFilter;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.OUTBOUND_EVENT_TYPE__FILTER, oldFilter, newFilter);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFilter(ExpressionSpecificationType newFilter) {
		if (newFilter != filter) {
			NotificationChain msgs = null;
			if (filter != null)
				msgs = ((InternalEObject)filter).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.OUTBOUND_EVENT_TYPE__FILTER, null, msgs);
			if (newFilter != null)
				msgs = ((InternalEObject)newFilter).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.OUTBOUND_EVENT_TYPE__FILTER, null, msgs);
			msgs = basicSetFilter(newFilter, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.OUTBOUND_EVENT_TYPE__FILTER, newFilter, newFilter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getExtensionName() {
		return extensionName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExtensionName(String newExtensionName) {
		String oldExtensionName = extensionName;
		extensionName = newExtensionName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.OUTBOUND_EVENT_TYPE__EXTENSION_NAME, oldExtensionName, extensionName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getRootElement() {
		return rootElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRootElement(Object newRootElement) {
		Object oldRootElement = rootElement;
		rootElement = newRootElement;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.OUTBOUND_EVENT_TYPE__ROOT_ELEMENT, oldRootElement, rootElement));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MmPackage.OUTBOUND_EVENT_TYPE__EVENT_PART:
				return ((InternalEList)getEventPart()).basicRemove(otherEnd, msgs);
			case MmPackage.OUTBOUND_EVENT_TYPE__MAP:
				return ((InternalEList)getMap()).basicRemove(otherEnd, msgs);
			case MmPackage.OUTBOUND_EVENT_TYPE__FILTER:
				return basicSetFilter(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MmPackage.OUTBOUND_EVENT_TYPE__EVENT_PART:
				return getEventPart();
			case MmPackage.OUTBOUND_EVENT_TYPE__MAP:
				return getMap();
			case MmPackage.OUTBOUND_EVENT_TYPE__FILTER:
				return getFilter();
			case MmPackage.OUTBOUND_EVENT_TYPE__EXTENSION_NAME:
				return getExtensionName();
			case MmPackage.OUTBOUND_EVENT_TYPE__ROOT_ELEMENT:
				return getRootElement();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MmPackage.OUTBOUND_EVENT_TYPE__EVENT_PART:
				getEventPart().clear();
				getEventPart().addAll((Collection)newValue);
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__MAP:
				getMap().clear();
				getMap().addAll((Collection)newValue);
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__FILTER:
				setFilter((ExpressionSpecificationType)newValue);
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__EXTENSION_NAME:
				setExtensionName((String)newValue);
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__ROOT_ELEMENT:
				setRootElement((Object)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case MmPackage.OUTBOUND_EVENT_TYPE__EVENT_PART:
				getEventPart().clear();
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__MAP:
				getMap().clear();
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__FILTER:
				setFilter((ExpressionSpecificationType)null);
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__EXTENSION_NAME:
				setExtensionName(EXTENSION_NAME_EDEFAULT);
				return;
			case MmPackage.OUTBOUND_EVENT_TYPE__ROOT_ELEMENT:
				setRootElement(ROOT_ELEMENT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MmPackage.OUTBOUND_EVENT_TYPE__EVENT_PART:
				return eventPart != null && !eventPart.isEmpty();
			case MmPackage.OUTBOUND_EVENT_TYPE__MAP:
				return map != null && !map.isEmpty();
			case MmPackage.OUTBOUND_EVENT_TYPE__FILTER:
				return filter != null;
			case MmPackage.OUTBOUND_EVENT_TYPE__EXTENSION_NAME:
				return EXTENSION_NAME_EDEFAULT == null ? extensionName != null : !EXTENSION_NAME_EDEFAULT.equals(extensionName);
			case MmPackage.OUTBOUND_EVENT_TYPE__ROOT_ELEMENT:
				return ROOT_ELEMENT_EDEFAULT == null ? rootElement != null : !ROOT_ELEMENT_EDEFAULT.equals(rootElement);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (extensionName: ");
		result.append(extensionName);
		result.append(", rootElement: ");
		result.append(rootElement);
		result.append(')');
		return result.toString();
	}

	/**
	 * This method determines whether this OutboundEventType is referencing a 6.0.2-style .CBE event definition
	 * or a set of 6.1+ style XSD event definitions 
	 */
	public boolean hasCBEDefinition(){
		/* If there is an extensionName defined, we can assume that the reference is to 
		 * a 6.0.2-style CBE event definition */
		return getExtensionName() != null;
	}
	
	/**
	 * This method provides access to the CBE event type object referenced by this OutboundEventType.  This method 
	 * attempts to resolve the path to the actual event definition in its external file, if possible.  Note that if 
	 * this outbound event does not refer to a .CBE-style event, null is returned.
	 * 
	 * NOTE: This method requires that the OutboundEventType object be associated to a Resource and ResourceSet indirectly
	 * via its containment hierarchy.
	 * 
	 * @deprecated Use getCbeEventObject() instead
	 * 
	 * @return The event type object or null if the outbound event is not a .CBE style, or cannot be resolved
	 */
	public EObject getEventTypeObject(){
		return getCbeEventObject();
	}
	
	/**
	 * This method provides access to the CBE event type object referenced by this OutboundEventType.  This method 
	 * attempts to resolve the path to the actual event definition in its external file, if possible.  Note that if 
	 * this outbound event does not refer to a .CBE-style event, null is returned.
	 * 
	 * NOTE: This method requires that the OutboundEventType object be associated to a Resource and ResourceSet indirectly
	 * via its containment hierarchy.
	 * 
	 * @return The event type object or null if the outbound event is not a .CBE style, or cannot be resolved
	 */
	public com.ibm.wbimonitor.xml.model.eventdefinition501.EventDefinitionType getCbeEventObject(){
		if (hasCBEDefinition()){
			return (com.ibm.wbimonitor.xml.model.eventdefinition501.EventDefinitionType)EventTypeResolver.resolve(this, getExtensionName());
		} else {
			return null;
		}
	}

} //OutboundEventTypeImpl
