/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */ 
/**
 * <copyright>
 * </copyright>
 *
 * $Id: TriggerTypeImpl.java,v 1.1 2006/06/27 15:10:42 crmiles Exp $
 */
package com.ibm.wbimonitor.xml.model.mm.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.BasicFeatureMap;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.wbimonitor.xml.model.mm.ExpressionSpecificationType;
import com.ibm.wbimonitor.xml.model.mm.MmPackage;
import com.ibm.wbimonitor.xml.model.mm.TriggerType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Trigger Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#getGroup <em>Group</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#getOnTrigger <em>On Trigger</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#getEvaluationTime <em>Evaluation Time</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#getOnValueChange <em>On Value Change</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#getOnEvent <em>On Event</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#getGatingCondition <em>Gating Condition</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#isIsRepeatable <em>Is Repeatable</em>}</li>
 *   <li>{@link com.ibm.wbimonitor.xml.model.mm.impl.TriggerTypeImpl#isTerminateContext <em>Terminate Context</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TriggerTypeImpl extends NamedElementTypeImpl implements TriggerType {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2007.";  //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getGroup() <em>Group</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGroup()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap group = null;

	/**
	 * The cached value of the '{@link #getGatingCondition() <em>Gating Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGatingCondition()
	 * @generated
	 * @ordered
	 */
	protected ExpressionSpecificationType gatingCondition = null;

	/**
	 * The default value of the '{@link #isIsRepeatable() <em>Is Repeatable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsRepeatable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_REPEATABLE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsRepeatable() <em>Is Repeatable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsRepeatable()
	 * @generated
	 * @ordered
	 */
	protected boolean isRepeatable = IS_REPEATABLE_EDEFAULT;

	/**
	 * This is true if the Is Repeatable attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean isRepeatableESet = false;

	/**
	 * The default value of the '{@link #isTerminateContext() <em>Terminate Context</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isTerminateContext()
	 * @generated
	 * @ordered
	 */
	protected static final boolean TERMINATE_CONTEXT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isTerminateContext() <em>Terminate Context</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isTerminateContext()
	 * @generated
	 * @ordered
	 */
	protected boolean terminateContext = TERMINATE_CONTEXT_EDEFAULT;

	/**
	 * This is true if the Terminate Context attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean terminateContextESet = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TriggerTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return MmPackage.Literals.TRIGGER_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getGroup() {
		if (group == null) {
			group = new BasicFeatureMap(this, MmPackage.TRIGGER_TYPE__GROUP);
		}
		return group;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOnTrigger() {
		return ((FeatureMap)getGroup()).list(MmPackage.Literals.TRIGGER_TYPE__ON_TRIGGER);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getEvaluationTime() {
		return ((FeatureMap)getGroup()).list(MmPackage.Literals.TRIGGER_TYPE__EVALUATION_TIME);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOnValueChange() {
		return ((FeatureMap)getGroup()).list(MmPackage.Literals.TRIGGER_TYPE__ON_VALUE_CHANGE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOnEvent() {
		return ((FeatureMap)getGroup()).list(MmPackage.Literals.TRIGGER_TYPE__ON_EVENT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpressionSpecificationType getGatingCondition() {
		return gatingCondition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGatingCondition(ExpressionSpecificationType newGatingCondition, NotificationChain msgs) {
		ExpressionSpecificationType oldGatingCondition = gatingCondition;
		gatingCondition = newGatingCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MmPackage.TRIGGER_TYPE__GATING_CONDITION, oldGatingCondition, newGatingCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGatingCondition(ExpressionSpecificationType newGatingCondition) {
		if (newGatingCondition != gatingCondition) {
			NotificationChain msgs = null;
			if (gatingCondition != null)
				msgs = ((InternalEObject)gatingCondition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MmPackage.TRIGGER_TYPE__GATING_CONDITION, null, msgs);
			if (newGatingCondition != null)
				msgs = ((InternalEObject)newGatingCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MmPackage.TRIGGER_TYPE__GATING_CONDITION, null, msgs);
			msgs = basicSetGatingCondition(newGatingCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.TRIGGER_TYPE__GATING_CONDITION, newGatingCondition, newGatingCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsRepeatable() {
		return isRepeatable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsRepeatable(boolean newIsRepeatable) {
		boolean oldIsRepeatable = isRepeatable;
		isRepeatable = newIsRepeatable;
		boolean oldIsRepeatableESet = isRepeatableESet;
		isRepeatableESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.TRIGGER_TYPE__IS_REPEATABLE, oldIsRepeatable, isRepeatable, !oldIsRepeatableESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetIsRepeatable() {
		boolean oldIsRepeatable = isRepeatable;
		boolean oldIsRepeatableESet = isRepeatableESet;
		isRepeatable = IS_REPEATABLE_EDEFAULT;
		isRepeatableESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.TRIGGER_TYPE__IS_REPEATABLE, oldIsRepeatable, IS_REPEATABLE_EDEFAULT, oldIsRepeatableESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetIsRepeatable() {
		return isRepeatableESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isTerminateContext() {
		return terminateContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTerminateContext(boolean newTerminateContext) {
		boolean oldTerminateContext = terminateContext;
		terminateContext = newTerminateContext;
		boolean oldTerminateContextESet = terminateContextESet;
		terminateContextESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MmPackage.TRIGGER_TYPE__TERMINATE_CONTEXT, oldTerminateContext, terminateContext, !oldTerminateContextESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetTerminateContext() {
		boolean oldTerminateContext = terminateContext;
		boolean oldTerminateContextESet = terminateContextESet;
		terminateContext = TERMINATE_CONTEXT_EDEFAULT;
		terminateContextESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, MmPackage.TRIGGER_TYPE__TERMINATE_CONTEXT, oldTerminateContext, TERMINATE_CONTEXT_EDEFAULT, oldTerminateContextESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetTerminateContext() {
		return terminateContextESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MmPackage.TRIGGER_TYPE__GROUP:
				return ((InternalEList)getGroup()).basicRemove(otherEnd, msgs);
			case MmPackage.TRIGGER_TYPE__ON_TRIGGER:
				return ((InternalEList)getOnTrigger()).basicRemove(otherEnd, msgs);
			case MmPackage.TRIGGER_TYPE__EVALUATION_TIME:
				return ((InternalEList)getEvaluationTime()).basicRemove(otherEnd, msgs);
			case MmPackage.TRIGGER_TYPE__ON_VALUE_CHANGE:
				return ((InternalEList)getOnValueChange()).basicRemove(otherEnd, msgs);
			case MmPackage.TRIGGER_TYPE__ON_EVENT:
				return ((InternalEList)getOnEvent()).basicRemove(otherEnd, msgs);
			case MmPackage.TRIGGER_TYPE__GATING_CONDITION:
				return basicSetGatingCondition(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MmPackage.TRIGGER_TYPE__GROUP:
				if (coreType) return getGroup();
				return ((FeatureMap.Internal)getGroup()).getWrapper();
			case MmPackage.TRIGGER_TYPE__ON_TRIGGER:
				return getOnTrigger();
			case MmPackage.TRIGGER_TYPE__EVALUATION_TIME:
				return getEvaluationTime();
			case MmPackage.TRIGGER_TYPE__ON_VALUE_CHANGE:
				return getOnValueChange();
			case MmPackage.TRIGGER_TYPE__ON_EVENT:
				return getOnEvent();
			case MmPackage.TRIGGER_TYPE__GATING_CONDITION:
				return getGatingCondition();
			case MmPackage.TRIGGER_TYPE__IS_REPEATABLE:
				return isIsRepeatable() ? Boolean.TRUE : Boolean.FALSE;
			case MmPackage.TRIGGER_TYPE__TERMINATE_CONTEXT:
				return isTerminateContext() ? Boolean.TRUE : Boolean.FALSE;
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MmPackage.TRIGGER_TYPE__GROUP:
				((FeatureMap.Internal)getGroup()).set(newValue);
				return;
			case MmPackage.TRIGGER_TYPE__ON_TRIGGER:
				getOnTrigger().clear();
				getOnTrigger().addAll((Collection)newValue);
				return;
			case MmPackage.TRIGGER_TYPE__EVALUATION_TIME:
				getEvaluationTime().clear();
				getEvaluationTime().addAll((Collection)newValue);
				return;
			case MmPackage.TRIGGER_TYPE__ON_VALUE_CHANGE:
				getOnValueChange().clear();
				getOnValueChange().addAll((Collection)newValue);
				return;
			case MmPackage.TRIGGER_TYPE__ON_EVENT:
				getOnEvent().clear();
				getOnEvent().addAll((Collection)newValue);
				return;
			case MmPackage.TRIGGER_TYPE__GATING_CONDITION:
				setGatingCondition((ExpressionSpecificationType)newValue);
				return;
			case MmPackage.TRIGGER_TYPE__IS_REPEATABLE:
				setIsRepeatable(((Boolean)newValue).booleanValue());
				return;
			case MmPackage.TRIGGER_TYPE__TERMINATE_CONTEXT:
				setTerminateContext(((Boolean)newValue).booleanValue());
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case MmPackage.TRIGGER_TYPE__GROUP:
				getGroup().clear();
				return;
			case MmPackage.TRIGGER_TYPE__ON_TRIGGER:
				getOnTrigger().clear();
				return;
			case MmPackage.TRIGGER_TYPE__EVALUATION_TIME:
				getEvaluationTime().clear();
				return;
			case MmPackage.TRIGGER_TYPE__ON_VALUE_CHANGE:
				getOnValueChange().clear();
				return;
			case MmPackage.TRIGGER_TYPE__ON_EVENT:
				getOnEvent().clear();
				return;
			case MmPackage.TRIGGER_TYPE__GATING_CONDITION:
				setGatingCondition((ExpressionSpecificationType)null);
				return;
			case MmPackage.TRIGGER_TYPE__IS_REPEATABLE:
				unsetIsRepeatable();
				return;
			case MmPackage.TRIGGER_TYPE__TERMINATE_CONTEXT:
				unsetTerminateContext();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MmPackage.TRIGGER_TYPE__GROUP:
				return group != null && !group.isEmpty();
			case MmPackage.TRIGGER_TYPE__ON_TRIGGER:
				return !getOnTrigger().isEmpty();
			case MmPackage.TRIGGER_TYPE__EVALUATION_TIME:
				return !getEvaluationTime().isEmpty();
			case MmPackage.TRIGGER_TYPE__ON_VALUE_CHANGE:
				return !getOnValueChange().isEmpty();
			case MmPackage.TRIGGER_TYPE__ON_EVENT:
				return !getOnEvent().isEmpty();
			case MmPackage.TRIGGER_TYPE__GATING_CONDITION:
				return gatingCondition != null;
			case MmPackage.TRIGGER_TYPE__IS_REPEATABLE:
				return isSetIsRepeatable();
			case MmPackage.TRIGGER_TYPE__TERMINATE_CONTEXT:
				return isSetTerminateContext();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (group: ");
		result.append(group);
		result.append(", isRepeatable: ");
		if (isRepeatableESet) result.append(isRepeatable); else result.append("<unset>");
		result.append(", terminateContext: ");
		if (terminateContextESet) result.append(terminateContext); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //TriggerTypeImpl
