/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2006, 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.wbimonitor.xml.model.util;


/**
 * A Dynamic context for the purpose of using JXpath.
 */
public class MmDynamicContextBean {
public static final String COPYRIGHT="(C) Copyright IBM Corporation 2006, 2007.";  //$NON-NLS-1$

	

	/**
	 * The actual context object.
	 */
	private Object contextObject = null;
	
	/**
	 * Static step.
	 */
	private String staticStep = null;

	/**
	 *
	 */
	public MmDynamicContextBean(Object contextObject) {
		super();
		this.contextObject = contextObject;
	}




	/**
	 * @return Returns the contextObject.
	 */
	public Object getContextObject() {
		return contextObject;
	}
	
	public boolean isStaticStep() {
		return staticStep != null;
	}
	
	/**
	 * @return Returns the staticStep.
	 */
	public String getStaticStep() {
		return staticStep;
	}
	/**
	 * @param staticStep The staticStep to set.
	 */
	public void setStaticStep(String staticStep) {
		this.staticStep = staticStep;
	}
}
