/* IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * (C) Copyright IBM Corporation 2006, 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.wbimonitor.xml.model.util;

import org.eclipse.emf.ecore.EObject;

public class MonitorContextResolver extends ModelContextResolver {
public static final String COPYRIGHT="(C) Copyright IBM Corporation 2006, 2007.";  //$NON-NLS-1$

	
	private static MonitorContextResolver sInstance;
	
	private MonitorContextResolver(){
	}
	
	public static MonitorContextResolver getInstance(){
		if (sInstance == null){
			sInstance = new MonitorContextResolver();
		}
		return sInstance;
	}
	
	public EObject getContextObject(EObject source, EObject target){
		return getAbsolutePathContextObject(source);
	}
	
	/**
	 * This implementation returns the absolute path context object
	 * as the root.  No relative paths in this case.
	 */
	public EObject getContextObject(EObject source){
		
		return getAbsolutePathContextObject(source);
		
	}	
	
}
