/* 
  Licensed Materials - Property of IBM
  5655-FLW (C) Copyright IBM Corporation 2007. All Rights Reserved.
  US Government Users Restricted Rights- Use, duplication or disclosure
*/

var wshShell = WScript.createobject("WScript.Shell");
var fileObject = WScript.createobject("Scripting.FileSystemObject");
var startMenuLocation = wshShell.SpecialFolders("Programs");

var forReading = 1;
var tristateUseDefault = -2;
var txtFilePath = "${WASROOT}/properties/version/install.wbm/config/install/productShortCut2StartMenuWBM.txt";
var f = fileObject.GetFile(txtFilePath);
var ts = f.OpenAsTextStream(forReading, tristateUseDefault);
var icounter = ts.ReadLine();
ts.Close();

var scounter;
if (icounter == 0)
      scounter = "";
else
      scounter = " (" + icounter + ")";

// Get OS version. Ver 6 = Win Vista
var env = wshShell.Environment;
var osid = env("PROCESSOR_IDENTIFIER");
var osver = osid.charAt(osid.indexOf("Family") + 7);
WScript.StdOut.WriteLine("OS ID = " + osid + " ==> ver = " + osver);
      
//Registry reader to get the location of IE
var key = "HKEY_LOCAL_MACHINE\\";
// Get path to IE. Vista has different registry path
var key = "HKEY_LOCAL_MACHINE\\";
var iePath = "";
if (osver == 6)
	iePath = wshShell.RegRead(key + "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\IEXPLORE.EXE\\");
else
    iePath = wshShell.RegRead(key + "SOFTWARE\\Microsoft\\IE Setup\\Setup\\Path") + "\\IEXPLORE.EXE";
    
WScript.StdOut.WriteLine("IE Path = " + iePath);

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM WebSphere")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM WebSphere");
      
if (!(fileObject.FolderExists(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter)))
      fileObject.CreateFolder(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter);

var objShellLinkInfoCenter = wshShell.CreateShortcut(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter + "\\${INFOCENTER}.lnk");
var objShellLinkOnlineSupport = wshShell.CreateShortcut(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter + "\\${ONLINESUPPORT}.lnk");
var objShellLinkPCAT = wshShell.CreateShortcut(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter + "\\${PROFILECREATION}.lnk");
var objShellLinkFirstSteps = wshShell.CreateShortcut(startMenuLocation + "\\IBM WebSphere\\Business Monitor 6.1" + scounter + "\\${FIRSTSTEPS}.lnk");

//1: Activates and displays a window. If the window is minimized or maximized, the system restores it to its original size and position. 
//3: Activates the window and displays it as a maximized window.  
//7: Minimizes the window and activates the next top-level window. 
objShellLinkInfoCenter.WindowStyle = 1;
objShellLinkOnlineSupport.WindowStyle = 1;
objShellLinkPCAT.WindowStyle = 1;
objShellLinkFirstSteps.WindowStyle = 7;

objShellLinkInfoCenter.IconLocation = "${WASROOT}\\bin\\icons\\infocenter.ico";
objShellLinkInfoCenter.TargetPath = iePath;
objShellLinkInfoCenter.Description = "${INFOCENTER}";
objShellLinkInfoCenter.Arguments = "http://publib.boulder.ibm.com/infocenter/dmndhelp/v6rxmx/index.jsp";
objShellLinkInfoCenter.Save(); //commit change

objShellLinkOnlineSupport.IconLocation = "${WASROOT}\\bin\\icons\\support.ico";
objShellLinkOnlineSupport.TargetPath = iePath;
objShellLinkOnlineSupport.Description = "${ONLINESUPPORT}";
objShellLinkOnlineSupport.Arguments = "http://www.ibm.com/software/integration/wbimonitor/support/";
objShellLinkOnlineSupport.Save(); //commit change

var pmtCmd = "pmt.bat";
if ((fileObject.FileExists("${WASROOT}" + "\\bin\\ProfileManagement\\pmt.bat")))
	pmtCmd = "pmt.bat";
	
objShellLinkPCAT.IconLocation = "${WASROOT}\\bin\\icons\\profile_creation_icon.ico";
objShellLinkPCAT.TargetPath = "${WASROOT}\\bin\\ProfileManagement\\" + pmtCmd; 
objShellLinkPCAT.WorkingDirectory = "${WASROOT}\\bin\\ProfileManagement";
objShellLinkPCAT.Description = "${PROFILECREATION}";
objShellLinkPCAT.Save(); //commit change

objShellLinkFirstSteps.IconLocation = "${WASROOT}\\bin\\icons\\firststeps.ico";
objShellLinkFirstSteps.TargetPath = "${WASROOT}\\firststeps.wbm\\firststeps.bat";
objShellLinkFirstSteps.WorkingDirectory = "${WASROOT}\\firststeps.wbm";
objShellLinkFirstSteps.Description = "${FIRSTSTEPS}";
objShellLinkFirstSteps.Save(); //commit change
